// bsls_stackaddressutil_plinktimestamp.h                             -*-C++-*-
#ifndef INCLUDED_BSLS_STACKADDRESSUTIL_PLINKTIMESTAMP
#define INCLUDED_BSLS_STACKADDRESSUTIL_PLINKTIMESTAMP

#include <bsls_ident.h>
BSLS_IDENT("$Id: $")

//@PURPOSE: Declare and weakly define a `plink_timestamp___` global variable.
//
//@DESCRIPTION: This component provides a weak definition of the Bloomberg
// standard `plink_timestamp__` variable, which is normally generated by any
// program that is built with the Bloomberg `plink` build system.  This array
// of null-terminated strings, ending in a `0`, normally contains data useful
// in identifying when and how a particular task was built.
//
// The definition provided by this component is an array containing a single
// `0` value with `weak` linkage, which should cause it to be only linked into
// an application in build systems that don't generate a definition for this
// variable themselves.  Note that "dummy" definitions of this symbol
// occasional use an array of empty strings, but that that would crash
// `sysutil_pwhat_getvar` if it ended up actually linking together and being
// called.

extern "C" const char *plink_timestamp___[];

#endif

// ----------------------------------------------------------------------------
// Copyright 2024 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
